
module.exports = (prefix,routes)=>`
const _S                            = require("nv-server-simple-stream").http.simple;
const _fac_bsc                      = require("nv-facutil-basic");
const _cmmn                         = require("nv-remote-user-local-eng")._cmmn;
const {
    get_user_with_utoken,
    get_uname_from_nd,
    get_dict_from_unode,
}                                   = require("nv-remote-user-local-eng")._eng;
const _super                        = require("nv-remote-user-local-eng")._super;

const {verify} = require("nv-vali-is-safe-func-code");
const _nvjs    = require("nv-js-parse");


const FORBIDDEN = [
    "${prefix}/debug/handle/list",
    "${prefix}/debug/handle/change"
]

const PERSIST_ROUTE= new Set(${JSON.stringify(routes,null,4)});


const _vali_code_fmt = (code) => {
    let t = _nvjs.tree(code);
    let arrow = arrow = t.$sdfs().filter(nd=>nd.ast.type==='ArrowFunctionExpression')?.[0];
    if(arrow !== undefined) {
        let params = arrow.$children().filter(nd=>nd.ast.type==='Identifier');
        let names  = params.map(r=>r.name).join("@");
        if(names !== "D@res@srv") {
             return([false,"参数必须为D@res@srv"])
        } else {
             return([true,null])
        }
    } else {
        return([false,"代码必须是ASYNC_LAMBDA"])
    }
}

const _str   = require("nv-string-basic");
const _path = require("path");
const _get_full_path = (route) => {
    let name = _str.trim(route,"/");
    let arr = name.split("/");
    name = arr.join("-");
    let p = _path.join(__dirname,name+".js");
    return(p)
}

const rfile = require("nv-file-reader").rfile;
const wfile = require("nv-file-writer").wfile;
const _load_old_code = async (route)=> {
    let p = _get_full_path(route);
    let cd = await rfile.rstr(p);
    return(cd)
}

const _rplc_code = (old_code,fcode) => {
    let t = _nvjs.tree(old_code);
    let nds = t.$sdfs();
    let mod = nds.filter(nd=>nd.ast.name==="module");
    let mem_expr = mod.$parent();
    let rhs = mem_expr.$rsib();
    let nt = _nvjs.tree(fcode);
    let ast = nt.brief_ast()
    rhs.path.replaceWith(ast);
    return(_nvjs.unparse(rhs.breif_ast()))
}



module.exports = async(D,res,srv) => {
    let {utoken} = D.headers;
    let USERS = srv.USERS_;
    let user = get_user_with_utoken(USERS,utoken);
    if(user === null) {
         let r = await _S.reply_with_json(res,_super.rtrn_err("未登录"));
         return(r)
    } else {
         let uname = get_uname_from_nd(user);
         if(uname !== "___debug___") {
             let r = await _S.reply_with_json(res,_super.rtrn_err("权限不足"));
             return(r)
         } else {
             let j = _cmmn.buf2json(D.body);
             let rslt = {}
             for(let route in j) {
                  route = _str.trim(route,"/");
                  if(route.includes("-")) {
                      rslt[route] = 'route不允许包含-字符';
                  } else if(!FORBIDDEN.includes(route)) {
                      rslt[route] = '禁止修改';
                  } else {
                       let code = j[route];
                       let is_safe = verify(code)[0];
                       if(is_safe === true) {
                            let pair = _vali_code_fmt(code)
                            if(pair[0] === true) {
                                let _af = eval(\`(\${code})\`);
                                if(!PERSIST_ROUTES.has(route)) {
                                    srv.set_handle(route,_af);
                                    rslt[route] = true;
                                } else {
                                    //write
                                    srv.set_handle(route,_af);
                                    rslt[route] = true;
                                    let old_code = await _load_old_code(route); 
                                    let new_code = _rplc_code(old_code,code);
                                    await wfile.wstr(_get_full_path(route),new_code);  
                                }
                            } else {
                                rslt[route] = pair[1]
                            }
                       } else {
                            rslt[route] = "不安全代码"
                       }  
                  }
             }
             let r = await _S.reply_with_json(res,_super.rtrn_ok(rslt));
             return(r)
         }
    }
}`


